=== EXTERNAL/CMakeLists.txt ===
# Only build CSPARSE if we need to
IF(BUILD_CSPARSE AND G2O_USE_CSPARSE)
  ADD_SUBDIRECTORY(csparse)
ENDIF()

IF (G2O_HAVE_OPENGL)
  ADD_SUBDIRECTORY(freeglut)
ENDIF()
