=== g2o/apps/CMakeLists.txt ===
ADD_SUBDIRECTORY(g2o_cli)
ADD_SUBDIRECTORY(g2o_hierarchical)

IF (G2O_HAVE_OPENGL)
  ADD_SUBDIRECTORY(g2o_simulator)
ENDIF()

IF(QGLVIEWER_FOUND AND Qt5_FOUND)
  ADD_SUBDIRECTORY(g2o_viewer)
ENDIF()

IF(G2O_BUILD_LINKED_APPS)
  ADD_SUBDIRECTORY(linked_binaries)
ENDIF()
