=== g2o/types/CMakeLists.txt ===
# Pre-canned types
ADD_SUBDIRECTORY(data)
ADD_SUBDIRECTORY(slam2d)
ADD_SUBDIRECTORY(slam3d)
ADD_SUBDIRECTORY(sba)
ADD_SUBDIRECTORY(sim3)
ADD_SUBDIRECTORY(icp)
ADD_SUBDIRECTORY(sclam2d)

ADD_SUBDIRECTORY(slam2d_addons)
ADD_SUBDIRECTORY(slam3d_addons)

OPTION(G2O_BUILD_DEPRECATED_TYPES "Compile the deprecated types" OFF)
IF(G2O_BUILD_DEPRECATED_TYPES)
  ADD_SUBDIRECTORY(deprecated)
ENDIF()
