=== debian/changelog ===
ros-melodic-libg2o (2018.3.25-0stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 18 May 2018 13:49:00 -0000
